import os

class File(file):
    'replaces built-in file'
    def __init__(self, filename, mode='r', *args, **kwargs):
        try:
            return super(File, self).__init__(filename, mode, *args, **kwargs)
        except IOError, e:
            if 'w' in mode:
                _command('sudo touch %s', filename)
            r = _command('sudo chmod 777 %s 2> /dev/null', filename)
            if 0 != r:
                raise IOError("Cannot chmod %s (%r)" % (filename, r))
        return super(File, self).__init__(filename, mode, *args, **kwargs)

def _command(cmd, *args):
    cmd %= args
    retval = os.system(cmd)
    if retval != 0:
        raise OSError(cmd, retval)
    

def mkdir(filename, mode=0777):
    _command('sudo mkdir -p %s', filename)
    chmod(filename, mode)

def makedirs(name, mode=0777):
    'replaces os.makedirs'
    head, tail = os.path.split(name)
    if not tail:
        head, tail = os.path.split(head)
    if head and tail and not os.path.exists(head):
        makedirs(head, mode)
        if tail == os.curdir:
            return
    mkdir(name, mode)

def chmod(name, mode, recursive=False):
    if type(mode) in (int, long):
        mode = "%o" % mode
    _command("sudo chmod %s %s %s", "-R" if recursive else "", mode, name)
def chown(name, owner, group=None, recursive=False):
    if group is not None:
        owner = "%s:%s" % (owner, group)
    _command("sudo chown %s %s %s", "-R" if recursive else "", owner, name)

def make_shared_directory(path):
    current = ""
    for path_component in path.split(os.path.sep):
        current += os.path.sep + path_component
        if not os.path.exists(current):
            mkdir(current)
            chown(current, "root", "users", recursive=True)
            chmod(current, "g+rwx", recursive=True)


def link(src, dest):
    _command("sudo ln %s %s", src, dest)

def unlink(filename):
    _command("sudo rm -rf %s", filename)

def symlink(src, dest):
    _command("sudo ln -s %s %s", src, dest)

def kill(pid, sig):
    _command('sudo kill -%d %d', sig, pid)
