#!/usr/bin/python
# TODO
# 1. escape text fields properly

import time

import sys, os
sys.path.insert(0, '/opt/xiv/python/pspackages')

from xiv_xsf.console.canvas.all import *

def quick_msgbox(**kwargs):

    grid = geometry.Grid(1, 1)
    canvas = Canvas(grid)
    msgbox = MsgBox(canvas, **kwargs)
    grid.place(msgbox, 0, 0)
    canvas.add(msgbox)
    canvas.render()

def exact_placement_test():

    geometry_manager = ExactPlacement()
    canvas = Canvas(geometry_manager)
    info = InfoBox(canvas, label="INFOBOX")
    geometry_manager.place(info, WidgetGeometry(2, 2, 13, 13))
    canvas.add(info) 
    
    yn = YesNoBox(canvas, label="YESORNO")
    geometry_manager.place(yn, WidgetGeometry(11, 18, 6, 14))
    canvas.add(yn)

    canvas.render()


def grid_inputbox_test():

    grid = Grid(2, 2)
    canvas = Canvas(grid)
    info = InfoBox(canvas, label="Information", shadow=True)
    grid.place(info, 0, 0)
    canvas.add(info)

    info2 = InfoBox(canvas, label="More Information", shadow=True)
    canvas.add_grid(info2, 0, 1, anchor = Grid.LEFT | Grid.DOWN)

    inputbox = InputBox(canvas, label="Enter your name:", value="Default name")
    canvas.add_grid(inputbox, 1, 0, columnspan=2, pady=2, padx=2)

    canvas.render()

    msg = MsgBox(canvas, label="Your name was: %s" % inputbox.answer)

    canvas.remove(inputbox)
    canvas.add_grid(msg, 1, 0, columnspan=2, pady=2, padx=2)

    canvas.render()

def radiolist_test():

    grid = Grid(1, 1)
    canvas = Canvas(grid, backtitle="Radio test")

    radiolist = RadioList(canvas, label="Radio list")
    radiolist.items.append(RadioList.Item("95.5", "Reshet Bet"))
    radiolist.items.append(RadioList.Item("106", "Kol Hakampus"))

    canvas.add_grid(radiolist, 0, 0)
    canvas.render()

    quick_msgbox(label="Your response was: %s" % radiolist.answer)


def checklist_test():

    grid = Grid(1, 1)
    canvas = Canvas(grid, backtitle="Checklist test")

    checklist = CheckList(canvas, label="Choose your favorite days", title="Days checklist")
    checklist.items.append(CheckList.Item("Sun", "Sunday", CheckList.ON))
    checklist.items.append(CheckList.Item("Mon", "Monday"))
    checklist.items.append(CheckList.Item("Tue", "Tuesday"))
    checklist.items.append(CheckList.Item("Wed", "Wednesday"))
    checklist.items.append(CheckList.Item("Thu", "Thursday"))
    checklist.items.append(CheckList.Item("Fri", "Friday"))
    checklist.items.append(CheckList.Item("Sat", "Saturday"))
    
    canvas.add_grid(checklist, 0, 0, pady=3, padx=3)
    canvas.render()

    quick_msgbox(label="Your responses were: %s" % ', '.join(checklist.answer))

def menu_test():

    grid = Grid(1, 1)
    canvas = Canvas(grid, backtitle="menu test")

    menu = Menu(canvas, label="Choose your favorite days", title="Days menu", default_item="Thu")
    menu.items.append(Menu.Item("Sun", "Sunday"))
    menu.items.append(Menu.Item("Mon", "Monday"))
    menu.items.append(Menu.Item("Tue", "Tuesday"))
    menu.items.append(Menu.Item("Wed", "Wednesday"))
    menu.items.append(Menu.Item("Thu", "Thursday"))
    menu.items.append(Menu.Item("Fri", "Friday"))
    menu.items.append(Menu.Item("Sat", "Saturday"))
    
    canvas.add_grid(menu, 0, 0)
    canvas.render()

    quick_msgbox(label="Your response was: %s" % menu.answer)

def progressbar_test():

    grid = Grid(2, 2)
    canvas = Canvas(grid, backtitle="Progress bar test")

    infobox = InfoBox(canvas, label='''Please wait while your <b><blue>PHD</blue></b> thesis
is being deleted...''')    
    canvas.add_grid(infobox, 0, 0, columnspan=2)

    progressbar = ProgressBar(canvas, total_steps=5, bar_width=20, label="Progress Bar")

    canvas.add_grid(progressbar, 1, 0, columnspan=2)
    canvas.render()

    for i in range(5):
        time.sleep(1)
        progressbar.next_step()

def colors_test():

    text='''<red>Red and <b>bold red</b> and back to red.
<blue>Now, temporarily blue</blue> and automatically back to red.
<u></red>Underline, also in <green>green</green> and 
in <yellow>yellow</yellow>.<r>Reverse, also in <white>white</white> 
and in <magenta>magenta</magenta>'''
    
    quick_msgbox(label=text)

def process_test():

    g = Grid(1, 1)
    c = Canvas(g)

    items = ['1. First we do this', 
'2. Then we do that', 
'3. And last we do the other thing']
    p = Process(c, items)
    c.add_grid(p, 0, 0)
    c.render()

    time.sleep(1)
    p.next_step()
    time.sleep(1)
    p.next_step()
    time.sleep(1)

def autofit_test():

    g = Grid(2, 2)
    c = Canvas(g, backtitle="Autofit test")
    label='''Short
long1 <yellow>long2</yellow> long3 long4 long5 long6 long7 long8 long9 long10 long11
short
medium medium'''
    
    l1 = InfoBox(c, label=label)
    c.add_grid(l1, 0, 0, pady=0, padx=0)

    m1 = MsgBox(c, label=label)
    c.add_grid(m1, 1, 1, pady=0, padx=0)

    c.render()

def positioning():
   
    g = Grid(3, 3)
    c = Canvas(g, backtitle="Padding")
    
    l00 = InfoBox(c, label="padx=pady=0\nSizing: <red>FILL</red>")
    c.add_grid(l00, 1, 0, anchor=Grid.LEFT, sizing_mode=Grid.FILL, padx=0, pady=0)
    
    l01 = InfoBox(c, label="padx=pady=3\nSizing: <red>FILL</red>")
    c.add_grid(l01, 1, 1, sizing_mode=Grid.FILL, padx=3, pady=3)

    l02 = InfoBox(c, label="Anchor: LEFT+UP\nSizing: <red>MANUAL</red>\n(7, 20)\nNo pad", height=7, width=20)
    c.add_grid(l02, 1, 2, sizing_mode=Grid.MANUAL, anchor=Grid.LEFT | Grid.UP, padx=0, pady=0)

    l10 = InfoBox(c, label="Anchor: CENTER\nSizing: <red>BEST_FIT</red>")
    c.add_grid(l10, 2, 0)

    l11 = MsgBox(c, label="Anchor: RIGHT|DOWN\nSizing: <red>BEST_FIT</red>")
    c.add_grid(l11, 2, 1, anchor=Grid.RIGHT | Grid.DOWN)

    c.render()

def form_test():

    g = Grid(1, 1)
    c = Canvas(g)
    form = Form(c, label='<red>Form</red>', form_height=10)
    form.items.append(Form.Item(label='First'))
    form.items.append(Form.Item(label='Second label'))
    form.items.append(Form.Item(label='Third', value='Default'))
    c.add_grid(form, 0, 0)
    c.render()

    quick_msgbox(label="<red>Results:</red>\n" + "\n".join(['%s: %s' % (x.label, x.answer) for x in form.items]))

def form_manual_positioning_test():

    g = Grid(1, 1)
    c = Canvas(g)
    form = Form(c, label='<red>Form: manual positioning</red>', manual_positioning=True, form_height=10)
    form.items.append(Form.Item(label='First', label_y=1, label_x=1, value_y=2, value_x=1))
    form.items.append(Form.Item(label='Second label', label_y=3, label_x=3, value_y=4, value_x=3))
    form.items.append(Form.Item(label='Third', value='Default', label_y=5, label_x=5, value_y=6, value_x=5))
    c.add_grid(form, 0, 0)
    c.render()

    quick_msgbox(label="<red>Results:</red>\n" + "\n".join(['%s: %s' % (x.label, x.answer) for x in form.items]))

def filedialog_test():

    g = Grid(2, 2)
    g.set_row_sizes([1, 2])
    c = Canvas(g)

    c.add_grid(InfoBox(c, label="FileDialog test"), 0, 0)
    c.add_grid(InfoBox(c, label="Select a file"), 0, 1)

    fdialog = FileDialog(c)
    c.add_grid(fdialog, 1, 0, columnspan=2)    
    c.render()

    quick_msgbox(label="You've chosen: %s" % fdialog.answer)
    

def yesno_test():

    c = Canvas(Grid(1, 1))
    yn = YesNoBox(c, label="Do you want to go\nthrough all of the tests?")
    c.add_grid(yn, 0, 0)
    c.render()
    return yn.answer == YesNoBox.YES

def tailbox_test():

    c = Canvas(Grid(2, 1))
    tb = TailBox(c, file=r'/root/tal/canvas/test.py')
    mb = MsgBox(c, label='Boo ha ha')
    c.add_grid(tb, 0, 0)
    c.add_grid(mb, 1, 0)
    c.render()

def all_tests():

    try:
        exact_placement_test()
        grid_inputbox_test()
        radiolist_test()
        checklist_test()
        menu_test()
        progressbar_test()
        colors_test()
        process_test()
        positioning()
        form_test()
        form_manual_positioning_test()
        filedialog_test()
        autofit_test()
    except CancelPressed:
        quick_msgbox(label="Cancel pressed")

if __name__ == '__main__':
    if (yesno_test()):
        all_tests()
    else:
        pass
        #exact_placement_test()
        #grid_inputbox_test()
        #radiolist_test()
        #checklist_test()
        #menu_test()
        #progressbar_test()
        #colors_test()
        #process_test()
        #autofit_test()
        #positioning()
        #form_test()
        #form_manual_positioning_test()
        #filedialog_test()
        tailbox_test()
