from ..widget import InteractiveWidget

class ButtonBox(InteractiveWidget):

    default_properties = {'label': ''}            

    def best_fit(self, max_height, max_width):

        height_overhead = self.widget_frame_height + self.button_row_height

        label_height, label_width = self._text().fit( \
            max_height - height_overhead, 
            max_width - self.widget_frame_width)

        return label_height + height_overhead, \
            max(label_width + self.widget_frame_width, 
                self.button_row_width_ok_cancel)
    

class MsgBox(ButtonBox):

    def specific_repr(self, height, width):
        return '--msgbox "%s" "%d" "%d"' % (self._text().get(), height, width)


class YesNoBox(ButtonBox):

    YES = 0
    NO = 1

    def specific_repr(self, height, width):
        return '--yesno "%s" "%d" "%d"' % (self._text().get(), height, width)

    def process_results(self, program_results):
        self.answer = program_results.return_value


