from ..widget import InteractiveWidget

class InputBox(InteractiveWidget):

    default_properties = {'label': '', 'value': ''}
    input_field_height = 3

    def specific_repr(self, height, width):

        return '--inputbox "%s" "%d" "%d" "%s"' % \
            (self._text().get(), height, width, self['value'])

    def process_results(self, program_results):
        self.validate_return_value(program_results)
        self.answer = program_results.stderr

    def best_fit(self, max_height, max_width):

        height_overhead = self.widget_frame_height + self.button_row_height + \
            self.input_field_height
        width_overhead = self.widget_frame_width

        label_height, label_width = self._text().fit( \
            max_height - height_overhead, 
            max_width - width_overhead)

        return label_height + height_overhead, \
             max(label_width, self.button_row_width_ok_cancel) + width_overhead


