from infobox import InfoBox
from ..errors import CanvasException

class Process(InfoBox):

    def __init__(self, canvas, items):
        InfoBox.__init__(self, canvas)
        self.items = items
        self.canvas = canvas
        self.index = 0
        self.update_label()

    def update_label(self):
        s = []
        for index, item in enumerate(self.items):
            if index == self.index:
                s.append('<b><blue><r>%s</r></blue></b>' % item)
            else:
                s.append(item)

        self['label'] = '\n'.join(s)
        self.canvas.render()

    def next_step(self):
        self.index += 1
        if self.index == len(self.items):
            raise CanvasException("Process finished, no next step")

        self.update_label()

