#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

from xiv_xsf.utils.osutils import OsUtils

from linux import OsDevices

def instantiate():
    """Return an appropriate OsDevices object"""
    os_utils = OsUtils()
    os_name = os_utils.get_os_name()
    try:
        os_obj = __import__(__name__ + "." + os_name, {}, {}, [1])
    except ImportError, e:
        raise NotImplementedError("OS: " + os_name + " is not supported")

    os_devices = os_obj.OsDevices()
    return os_devices

def doit():
    os_devices = instantiate()
    return os_devices.get_all_paths()
