#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

import re

from common import CommonDevices
from xiv_xsf.utils.system_command import SystemCommand

class OsDevices(CommonDevices):
    LSDEV_CMD = [ "/usr/sbin/lsdev", "-Cc", "disk" ]
    RESCAN_CMD = [ "/usr/sbin/cfgmgr" ]

    def rescan_disk_devices(self):
        system_command = SystemCommand(self.RESCAN_CMD)
        system_command.run()
         
    def get_list_of_scsi_disk_devices(self):
        devices = []

        system_command = SystemCommand(self.LSDEV_CMD)

        system_command.run()
        out = system_command.out.split("\n")

        regexp = re.compile("^(hdisk\d+)\s+Available")
        for line in out:
            regexp_result = regexp.search(line)
            if (regexp_result is not None):
                devices.append("/dev/" + regexp_result.groups()[0])

        return devices
