#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

import re

from common import CommonDevices
from xiv_xsf.utils.system_command import SystemCommand

class OsDevices(CommonDevices):
    IOSCAN_CMD = [ "/usr/sbin/ioscan", "-fnkC", "disk" ]

    IOSCAN_RESCAN_CMD = [ "/usr/sbin/ioscan", "-fnC", "disk" ]
    INSF_RESCAN_CMD = [ "/usr/sbin/insf", "-ed", "sdisk" ]
    
    def rescan_disk_devices(self):
        system_command = SystemCommand(self.IOSCAN_RESCAN_CMD)
        system_command.run()
        system_command = SystemCommand(self.INSF_RESCAN_CMD)
        system_command.run()


    def get_list_of_scsi_disk_devices(self):
        devices = []

        system_command = SystemCommand(self.IOSCAN_CMD)

        system_command.run()
        ioscan_out = system_command.out.split("\n")

        regexp = re.compile("^\s*(\/dev\/\S+)\s+(\/dev\/\S+)")

        for i in range(0, len(ioscan_out)-1, 2):
            if (ioscan_out[i].split(":")[15] != "CLAIMED"):
                continue

            regexp_result = regexp.search(ioscan_out[i+1])
            if (regexp_result is not None):
                devices.append(regexp_result.groups()[0])

        return devices
