#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

from xiv_xsf.utils.osutils import OsUtils

def instantiate_filesystem_utils():
    """Detects the OS and returns the appropriate FsUtils object. FsUtils
    handles current OS filesystem data, i.e. currently mounted filesystems"""
    os_utils = OsUtils()
    os_name = os_utils.get_os_name()
    try:
        package = __import__(__name__ + "." + os_name, {}, {}, [1])
    except ImportError, e:
        raise NotImplementedError("OS: " + os_name + " is not supported")

    fs_utils = getattr(package, "SpecificFsUtils")()

    return fs_utils
