#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

from xiv_xsf.host.storage.filesystems.common import FsUtils, MountTabParser

class SpecificFsUtils(FsUtils):
    MOUNT_TAB_FILE = '/proc/mounts'

    def get_device_of_mount_point(self, mount_point):
        f = open(self.MOUNT_TAB_FILE, "r")
        mount_tab = f.readlines()
        f.close()

        return FsUtils.parse_mounttab_format(self, mount_point, mount_tab)

    def get_mount_tab_data(self):
        """Returns a dict representing a mount-tab-like format,
        dict's key is the mount point"""
        data = MountTabParser(read_file = "/proc/mounts")
        return data.parse()
