#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

from xiv_xsf.utils.osutils import OsUtils

def instantiate_vm_from_device(device):
    """Gets a path to a device, returns the appropriate VM object, i.e. for
    /dev/vx/dsk/myvol it returns a VeritasVM object.
    For /dev/sda1 returns the LinuxNative device. etc."""
    os_utils = OsUtils()
    os_name = os_utils.get_os_name()
    try:
        os_obj = __import__(__name__ + "." + os_name, {}, {}, [1])
    except ImportError, e:
        raise NotImplementedError("OS: " + os_name + " is not supported")

    vm_detector = getattr(os_obj, "VolumeManagerDetector")(device)
    volume_manager_object = vm_detector.get_vm_object()

    return volume_manager_object
