#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

import re

from xiv_xsf.host.specific.aix import odm
from xiv_xsf.host.storage.xiv_volume_discoverer.shared import PosixTasks, \
    InstantiateError
from xiv_xsf.utils.system_command import SystemCommand

class OsSpecific(PosixTasks):

    odm_util = odm.ODM()

    def get_device_of_mount_point(self, mount_point):
        device = None

        print [self.DF_BIN, '-l', mount_point]
        proc = SystemCommand([self.DF_BIN, '-l', mount_point])
        proc.run()

        mount_tab = proc.out.split("\n")

        regexp_string = "^%s\s+\((\S+)" % (mount_point)
        mount_regexp = re.compile(regexp_string)

        for line in mount_tab:
            match = mount_regexp.match(line)
            if match is not None:
                device = match.groups()[0]

        return device

