#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

import os
import re
import platform

if platform.system() != "cli":
    # IronPython/win32 doesn't have this module, we don't care.
    import subprocess

class InstantiateError(Exception):
    pass

class PathDoesntExistError(Exception):
    """Path doesn't exist exception class"""
    def __init__(self, path):
        self.path = path

    def __str__(self):
        return "Path '%s' doesn't exist" % self.path

class CommonTasks(object):
    def get_lun_serial(self, device):
        """Returns the SCSI LUN serial number of the given device
        get it by scsi inquiry
        """

        import xiv_xsf.scsy.device
        dev = xiv_xsf.scsy.device.Device()
        dev.open(device)
        scsi_unit_serial_number = dev.inquiry.evpd80()
        dev.close()

        return scsi_unit_serial_number

class PosixTasks(CommonTasks):
    pass

