#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 

import clr
clr.AddReference("System.Management")

import System.Management

from xiv_xsf.host.storage.xiv_volume_discoverer.shared import InstantiateError
from xiv_xsf.host.storage.xiv_volume_discoverer.shared import CommonTasks
import xiv_xsf.host.storage.volume_managers.windows

class OsSpecific(CommonTasks):
    def get_lun_serial(self, device):
        """Returns info for the given physical device name"""
        query = 'ASSOCIATORS OF {Win32_DiskDrive.DeviceID="%s"} where resultClass=Win32_PhysicalMedia' % device.replace("\\", "\\\\")
        result = System.Management.ManagementObjectSearcher(query).Get()
        if (result.Count < 1):
            raise InstantiateError("Cannot get disk info")
        enum = result.GetEnumerator()
        enum.MoveNext()
        lun_serial = enum.Current.GetPropertyValue("SerialNumber")

        return lun_serial
