#!/usr/bin/env python

import sys
import os
import socket
from SimpleHTTPServer import SimpleHTTPRequestHandler
from BaseHTTPServer import HTTPServer

def FATAL(error_message):
    sys.stderr.write(error_message.strip()+'\n')
    sys.exit(1)

class TrivialHTTPServer(HTTPServer):
    def handle_error(*args, **kwargs):
        pass

class TrivialHTTPRequestHandler(SimpleHTTPRequestHandler):
    fixed_file_name = None
    fixed_file_type = None
    def send_head(self):
        f = open(self.translate_path('/%s' % self.fixed_file_name), 'rb')
        self.send_response(200)
        self.send_header("Content-type", self.fixed_file_type)
        fs = os.fstat(f.fileno())
        self.send_header("Content-Length", str(fs[6]))
        self.send_header("Last-Modified", self.date_time_string())
        self.send_header("Content-Disposition", "attachment; filename=%s" % self.fixed_file_name)
        self.end_headers()
        return f
    def log_message(*args, **kwargs):
        pass

def start_file_specific_webserver(filename, type):
    iterations = 0
    TrivialHTTPRequestHandler.fixed_file_name = filename
    TrivialHTTPRequestHandler.fixed_file_type = type
    try:
        server = TrivialHTTPServer(('0.0.0.0', 80), TrivialHTTPRequestHandler)
    except socket.error, error:
        FATAL('failed running server: %s' % error.args[1].lower())
    try:
        while True:
            server.handle_request()
            iterations += 1
    except KeyboardInterrupt:
        sys.stdout.write(str(iterations))

def main(argv):
    if len(argv) != 3:
        FATAL('trivial webserver requires exactly two arguments')
    program_name, filename, type = argv
    filename = os.path.abspath(filename)
    try:
        open(filename)
    except IOError, error:
        FATAL("file %s is inaccessible: %s" % (filename, error.args[1].lower()))
    os.chdir(os.path.dirname(filename))
    start_file_specific_webserver(os.path.basename(filename), type)

if __name__ == '__main__':
    main(sys.argv)
