from collectors import CMD, XCLICollector, ShellCollector, DigiCollector, IPMICollector, ProcTreeCollector, \
    TreeCollector, SataSmartCollector, UPSCollector, LogFileCollector, OptionalShellCollector, KDBCollector
from moduleset import CacheNodesSet, ModulesSet, ManafacesSet, FastTestSet, UPSsSet

full_collection = (
    CMD(XCLICollector, 'system_counters_get'),
    CMD(XCLICollector, 'node_list'),
    CMD(XCLICollector, 'ups_list'),
    CMD(XCLICollector, 'disk_list'),
    CMD(XCLICollector, 'version_get'),
    CMD(XCLICollector, 'event_list', beg='-300'),
    CMD(XCLICollector, 'event_list', beg='-600'),
    CMD(XCLICollector, 'event_list', beg='-900'),
    CMD(XCLICollector, 'event_list', beg='-250', min_severity='warning'),
    CMD(ManafacesSet(LogFileCollector), '/var/log', 'messages', 'messages.1', 'messages.2'),
    CMD(ModulesSet(ShellCollector), 'uptime'),
    CMD(ModulesSet(ShellCollector), 'ps', '-ef'),
    CMD(ModulesSet(ShellCollector), 'netstat', '-an'),
    CMD(ModulesSet(ShellCollector), 'netstat', '-rn'),
    CMD(ModulesSet(ShellCollector), 'arp', '-n'),
    CMD(ModulesSet(ShellCollector), '/root_dir/stable/dandalf_read'),
    CMD(ModulesSet(OptionalShellCollector), 'dmidecode'),
    CMD(ModulesSet(IPMICollector), 'sensor'),
    CMD(ModulesSet(IPMICollector), 'sel elist'),
    CMD(ModulesSet(KDBCollector)),
    CMD(ModulesSet(DigiCollector)),
    CMD(ManafacesSet(ProcTreeCollector), 'mptscsih', 'mptstm', 'mpt'),
    CMD(ManafacesSet(TreeCollector), 'lsi dumps data', "$(ls -tr /manager_logs/lsi_dumps/* | tail -12)"),
    CMD(CacheNodesSet(SataSmartCollector), 'e0'),
    CMD(CacheNodesSet(SataSmartCollector), 'f0'),
    CMD(UPSsSet(UPSCollector)),
)
