from xiv_xsf.nextra.p9constants import MANAFACE_NUMBERS, MANAFACE_NODES, CACHE_NODE_NUMBERS, \
    DISK_NUMBERS, MODULE_NUMBERS, UPS_NUMBERS, DIGI_NUMBER

class BaseModuleSet(object):
    module_numbers = set()
    def __init__(self, collector_class):
        super(BaseModuleSet, self).__init__()
        self.collector_class = collector_class
        
    def __repr__(self):
        return '<%s for %s>' % (self.__class__.__name__, self.collector_class.__name__)

    def dispatch(self, *args, **kwargs):
        for module_number in self.module_numbers:
            self.collector.dispatch(module_number, *args, **kwargs)

    def __call__(self, *args, **kwargs):
        self.collector = self.collector_class(*args, **kwargs)
        return self

class CacheNodesSet(BaseModuleSet):
    module_numbers = CACHE_NODE_NUMBERS

class ModulesSet(BaseModuleSet):
    module_numbers = MODULE_NUMBERS

class ManafacesSet(BaseModuleSet):
    module_numbers = MANAFACE_NUMBERS

class UPSsSet(BaseModuleSet):
    module_numbers = UPS_NUMBERS

class FastTestSet(BaseModuleSet):
    module_numbers = (101,)
