#!/usr/bin/python

import sys
from  subprocess import Popen, PIPE, STDOUT, call
from optparse import OptionParser, make_option
import re
import os
import time

def get_loaded_drivers():
    modules = []
    p = Popen(['lsmod',], stdout=PIPE, stderr=STDOUT)
    output = p.communicate()[0].split('\n')
    for line in output:
        name = line.split(' ')[0]
        if name in ['Module', '']:
            continue
        modules.append(name)
    return modules

def unload_mptlan():
    p = Popen(['ifconfig', '-a'], stdout=PIPE, stderr=STDOUT)
    output = p.communicate()[0].split('\n')
    for line in output:
        match = re.match("(?P<fc_iface>fc[0-9]+).*", line)
        if match:
            cmd = "/sbin/ifconfig %s down"%(match.group('fc_iface'),)
            call(cmd, shell=True)
    return call("rmmod mptlan", shell=True)

def load_mpt(load_mptlan = False):
    ret = 0
    drivers = get_loaded_drivers()
    if 'mptbase' not in drivers:
        call("modprobe mptbase", shell=True)
    if 'mptctl' not in drivers:
        ret = call("modprobe mptctl", shell=True)
    return ret

def reload_mpt(load_mptlan = False):
    drivers = get_loaded_drivers()
    if 'mptlan' in drivers:
        unload_mptlan()
    if 'mptctl' in drivers:
        call('rmmod mptctl', shell=True)
    if 'mptbase' in drivers:
        call('rmmod mptbase', shell=True)
    drivers = get_loaded_drivers()
    if ('mptbase' in drivers):
        return False
    call("modprobe mptbase", shell=True)
    ret = call("modprobe mptctl", shell=True)
    if ret != 0:
        print "Can't load mptctl module, modprobe failed with error code %d"%(ret,)
        return False
    if load_mptlan:
        call("modprobe mptlan", shell=True)
    return True


