import logging

class UPSException(Exception):
    """Base class of the UPS package's exceptions. Should never be thrown."""
    description = 'unknown UPS exception'
    severity = logging.ERROR

class CredentialsIncorrectError(UPSException):
    description = 'incorrect credentials'

class UPSManagerException(UPSException):
    """Base class of all UPSManager exceptions."""

class CommandFailedError(UPSManagerException):
    """Thrown by the Manager whenever a requested command can't be performed."""

class CredentialsIncorrectError(UPSManagerException):
    """Thrown by the Manager whenever logging in fails."""
    description = "incorrect credentials"
    severity = logging.ERROR

