class Identify():
    """Distinguish between an XIV machine and other"""

    xiv_identifiers = [
                        {"vendor": "IBM", "product": "2810XIV"},
                        {"vendor": "XIV", "product": "NEXTRA"},
                    ]


    def is_xiv_device(self, dev_path):
        """Tells whether a given device is a nextra device or not (True /
        False), by sending a scsi inquiry and analyzing the vendor/product
        string"""
        from xiv_xsf.scsy.device import Device

        try:
            scsy_device = Device()
            scsy_device.open(dev_path)
            response =  scsy_device.inquiry()

            for identifier in self.xiv_identifiers:
                if (response.vendor_identification == identifier["vendor"] and \
                    response.product_identification == identifier["product"]):
                    return True

        except Exception, e:
            # We can get a variaty of exceptions for various reasons (no such
            # device file, not supporting scsi inquiry, supporting but not
            # returning vendor name. I think we should return False on all
            # cases.
            return False

        return False
