"""
p9client's debug assistance module. 
Nothing here is promised to be documented or reliable, use with care and read the source.
"""

import pickle
from xiv.dtypes import Bunch
from xcli.response import Response

def dump_full_state(filename, nextra):
    pickle.dump(list_everything(nextra), file(filename, 'w'))

def load_full_state(filename):
    return recover_response_objects(pickle.load(file(filename, 'r')))

def list_everything(nextra):
    results = Bunch()
    methods = []
    for method in nextra.__dict__:
        if method.endswith('_list'):
            methods.append(method)
    print 'listing:', 
    for method in methods:
        try:
            print '[ ' + method[:-5],
            results[method] = str(getattr(nextra, method)())
            print ']',
        except Exception, e:
            print ' {caught %s} ' % str(e),
            results[method] = e
    print '\nreturning %d results' % len(results)
    return results

def recover_response_objects(response_dictionary):
    result = Bunch()
    for command, response_string in response_dictionary.iteritems():
        result[command] = Response(response_string, command, 'debug')
    return result
