import logging

class XCLICommand(object):
    def __init__(self, logger_name, command, arguments={}, options={}):
        self.logger = logging.getLogger(logger_name)
        self.command = command
        self.arguments = arguments
        self.options = options
        self.logger.log(4, 'generated command xml %r' % self.xml)

    @property
    def xml(self):
        xml_elements = ['<command id="0" type="%s">' % self.command]
        for element in ('argument', 'option'):
            for parameter_name, parameter_value in getattr(self, element+'s').iteritems():
                xml_elements.append('<%s name="%s" value="%s" />' % (element, parameter_name, parameter_value))
        xml_elements.append('</command>')
        return "\n".join(xml_elements)

    def __str__(self):
        return "%s(%s)" % \
            (self.command, ", ".join("%s=%s" % (name, value) for name, value in self.arguments.iteritems()))

    def __repr__(self):
        return "<Command %s>" % self.__str__()
