from construct import *
from scsy.scsi_specifications.adapters import WithDefaults, ArbitrarySizeUnsignedInteger

XCLI_INPUT_BUFFER_SIZE=2**18

xcli_read_buffer = WithDefaults(
    Struct("READ_BUFFER_command",
        Const(UBInt8("operation_code"), 0x3c),
        EmbeddedBitStruct(
            Padding(3), # reserved
            Const(Bits("mode", 5), 0x1),
        ),
        UBInt32("command_id"),
        ArbitrarySizeUnsignedInteger(Bytes("command_length", 3), 3), 
        UBInt8("control"),
    ),
    defaults=dict(control=0, operation_code=0x3c, mode=1, command_id=0),
)

xcli_write_buffer = WithDefaults(
    Struct("WRITE_BUFFER_command",
        Const(UBInt8("operation_code"), 0x3b),
        EmbeddedBitStruct(
            Padding(3), # reserved
            Const(Bits("mode", 5), 0x1),
        ),
        UBInt32("command_id"),
        ArbitrarySizeUnsignedInteger(Bytes("command_length", 3), 3), 
        UBInt8("control"),
    ),
    defaults=dict(control=0, operation_code=0x3b, mode=1, command_id=0)
)
