class XCLICommand(object):
    options = {
        #'compress-output': 'yes',
        'print-header': 'no',
        'i-am-sure': 'yes',
    }
    def __init__(self, command_name, arguments={}, options={}, remote_target=None):
        self.command_name = command_name
        self.arguments = arguments
        self.options.update(options)
        self.remote_target = remote_target

    @property
    def xml(self):
        remote_target_str = ""
        if self.remote_target:
          remote_target_str = 'remote_target="%s"' % self.remote_target
        xml_elements = ['<command id="0" type="%s" %s >' % (self.command_name, remote_target_str)]
        for element in ('argument', 'option'):
            for parameter_name, parameter_value in getattr(self, element+'s').iteritems():
                xml_elements.append('<%s name="%s" value="%s" />' % (element, parameter_name, parameter_value))
        xml_elements.append('</command>')
        return "".join(xml_elements)

    def __str__(self):
        return "%s(%s)" % \
            (self.command_name, ", ".join("%s=%r" % (name, value) for name, value in self.arguments.iteritems()))

    def __repr__(self):
        return "<Command %s>" % self.__str__()
