#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 
# This small app takes the list of T10 Additional Sense Code (ASC)
# data and generates a Struct
"""

"""

input_file = "stds.txt"
output_file = "../stds.py"

# ================= header text for file ======================== 
header = """from construct import *

# set of Additional Sense Code data generated from the stds.txt file.
# use generate_stds.py to update these values

version_descriptor=SymmetricMapping(UBInt16("version_descriptor"),
    mapping = {
"""

# ================= footer text for file ======================== 
footer = """
    },
    default = "reserved",
)
"""

def generateFile():
    # TODO: a proper try and catch around here to catch any exceptions
    
   ifile = open(input_file,"r")
   ofile = open(output_file, "w")

   ofile.write(header)

   valid_data = False
   for line in ifile:
     if valid_data and (len(line) >= 9):
       code = "0x" + line[0:4]
       description = line.strip()[6:]
       ofile.write("  \"%s\" : %s,\n" % (description, code))

       # only start reading data once the ----- lineis reached
     if line.startswith("-----"):
        valid_data = True

   ofile.write(footer)
  
   ifile.close()
   ofile.close()

if __name__ == '__main__':
  generateFile() 
