#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 
from construct import * 
from xiv_xsf.scsy.commands.core import SCSIReadCommand

class TestUnitReady(SCSIReadCommand):
    #---------------------------------------------------------- helper functions
    def _getCommandDefaults(self):
        """command length must be defined, there is no default value"""
        return dict(operation_code=0, control=0)
        
    def _getCommandStruct(self):
        return Struct("TEST_UNIT_READY_command",
            Const(UBInt8("operation_code"), 0x00),
            Padding(4), 
            UBInt8("control"),
            )
            
    #-------------------------------------------------------------- Core Methods
    def extended(self,device, command, trim=True, raw=True):
        """TEST_UNIT_READY command
        
        NOTE: There is no processing of the output so raw is ignored
        """
        return device.commandIn(command,
                         0,
                         trim
                         )