#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 
from construct import * 
from xiv_xsf.scsy.commands.core import SCSIWriteCommand
from xiv_xsf.scsy.utils import ArbitrarySizeUnsignedInteger

class WriteBuffer(SCSIWriteCommand):
    #---------------------------------------------------------- helper functions
    def _getCommandDefaults(self):
        """command length must be defined, there is no default value"""
        return dict(control=0, operation_code=0x3b, mode=1, command_id=0,
                    command_length = None)
        
    def _getCommandStruct(self):
        return Struct("WRITE_BUFFER_command",
            Const(UBInt8("operation_code"), 0x3b),
            EmbeddedBitStruct(
                Padding(3), # reserved
                Const(Bits("mode", 5), 0x1),
                ),
            UBInt32("command_id"),
            ArbitrarySizeUnsignedInteger(Bytes("command_length", 3), 3), 
            UBInt8("control"),
            )
        
