#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 
from xiv_xsf.scsy.raw.raw_device import *
#from xiv_xsf.scsy.raw.api_utils.test_vectors import bufferPrint16
from array import *
import struct 
import fcntl 
from construct import *
from cstruct import scsi_hdr_linux_i386


class Device(RawSCSIDevice):
    READ_TRANSFER_TYPE         = -3
    WRITE_TRANSFER_TYPE        = -2
    SG_IO                      =  0x2285
    SCSI_IOCTL_GET_BUS_NUMBER  =  0x5386
    SCSI_IOCTL_GET_IDLUN       =  0x5382
    
    def openHandle(self, device_path):
        
        # TODO: get right flags for open
        # TODO: catch file open exceptions
        self.handle = open(device_path,'r')
 
            # make sure that its a SCSI device
#        bus = struct.pack("i",0)
#        res = fcntl.ioctl(self.handle, self.SCSI_IOCTL_GET_BUS_NUMBER,0)
#        
#        #lun = struct.unpack("i",res)[0]
#        print "RES", res, "BUS", struct.unpack("i",bus)[0]
#        
#        if res < 0:
#            self.closeHandle()
#            raise NotSCSIDevice(device_path)
            

        
    def closeHandle(self):
        if None != self.handle:
            self.handle.close()
            self.handle = None
        
    def sendRawCommand(self, direction_read, cdb,
                       data_ptr, data_len):
        
        if None == self.handle:
            raise DeviceNotOpen
   
        cdb_buffer = array('B',cdb)
        cdb_ptr, cdb_len = cdb_buffer.buffer_info()
             
        if True == direction_read:
            dirn = self.READ_TRANSFER_TYPE
        else:
            dirn = self.WRITE_TRANSFER_TYPE
   
        sense_buffer = array('B',[0] * 252)
        sense_ptr, sense_len = sense_buffer.buffer_info()                
        
        data =  struct.pack("iiBBHIPPPIIiPBBBBHHiII",
                ord('S'), # ud
                dirn, # dxfe dirn
                cdb_len, # cdb len
                sense_len, # sb len
                0, # iovec count
                data_len, # dxfer len
                data_ptr, # data p
                cdb_ptr,  # cmd p
                sense_ptr,
                SCSI_TIMEOUT, # timeout
                0,  # flags
                0, # pack id
                0, # user ptr
                0, # status
                0, # masked_status
                0, # msb status
                0, # sb_len_wr,
                0, # host status
                0, # driver status
                0, # dxfer_len
                0, # duration
                0,  # info 
             )

        # TODO: add try catch
        # throws an IOError
        # max data length is 1024 bytes - longer will call a segmentation violation
        resp =  fcntl.ioctl(self.handle,self.SG_IO,data)
        
        #print struct.unpack("iiBBHIPPPIIiPBBBBHHiII",resp)
       
        response = scsi_hdr_linux_i386.parse(resp)
        #print response
        #from xiv_xsf.scsy.commands.sense import sense_data
        #print sense_data.parse(sense_buffer)
        
        if 2 == response.status:
            raise SenseReceived(sense_buffer)
        
        return response
      

  
