#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 
from xiv_xsf.scsy.raw.api_utils.test_vectors import *
from xiv_xsf.scsy.raw.api_utils.constants import *
from array import *
from struct import *
from fcntl import *
from construct import *
from cstruct import *


# typedef struct sg_io_hdr
# {
#     int interface_id;           /* [i] 'S' for SCSI generic (required) */
#     int dxfer_direction;        /* [i] data transfer direction  */
#     unsigned char cmd_len;      /* [i] SCSI command length ( <= 16 bytes) */
#     unsigned char mx_sb_len;    /* [i] max length to write to sbp */
#     unsigned short iovec_count; /* [i] 0 implies no scatter gather */
#     unsigned int dxfer_len;     /* [i] byte count of data transfer */
#     void __user *dxferp;        /* [i], [*io] points to data transfer memory
#                                               or scatter gather list */
#     unsigned char __user *cmdp; /* [i], [*i] points to command to perform */
#     void __user *sbp;           /* [i], [*o] points to sense_buffer memory */
#     unsigned int timeout;       /* [i] MAX_UINT->no timeout (unit: millisec) */
#     unsigned int flags;         /* [i] 0 -> default, see SG_FLAG... */
#     int pack_id;                /* [i->o] unused internally (normally) */
#     void __user * usr_ptr;      /* [i->o] unused internally */
#     unsigned char status;       /* [o] scsi status */
#     unsigned char masked_status;/* [o] shifted, masked scsi status */
#     unsigned char msg_status;   /* [o] messaging level data (optional) */
#     unsigned char sb_len_wr;    /* [o] byte count actually written to sbp */
#     unsigned short host_status; /* [o] errors from host adapter */
#     unsigned short driver_status;/* [o] errors from software driver */
#     int resid;                  /* [o] dxfer_len - actual_transferred */
#     unsigned int duration;      /* [o] time taken by cmd (unit: millisec) */
#     unsigned int info;          /* [o] auxiliary information */
# } sg_io_hdr_t;  /* 64 bytes long (on i386) */

# to confirm that size is correct
# print "SIZE  ", calcsize("iiBBHIPPPIIiPBBBBHHiII")

READ_TRANSFER_TYPE  = -3
WRITE_TRANSFER_TYPE = -2
SCSI_TIMEOUT = 15000
SG_IO=  0x2285 


def getStruct(handle, direction_read,cdb_ptr, cdb_len,
              data_ptr, data_len):
    
    #assert(isinstance(direction, bool))
    if True == direction_read:
        dirn = READ_TRANSFER_TYPE
    else:
        dirn = WRITE_TRANSFER_TYPE
    
    sense_buffer = array('c', '\0' * SENSE_BUFFER_SIZE)
    sense_buffer_ptr,sense_bufer_len = sense_buffer.buffer_info()
        
    data =  pack("iiBBHIPPPIIiPBBBBHHiII",
                ord('S'), # ud
                dirn, # dxfe dirn
                cdb_len, # cdb len
                sense_bufer_len, # sb len
                0, # iovec count
                data_len, # dxfer len
                data_ptr, # data p
                cdb_ptr,  # cmd p
                sense_buffer_ptr,
                SCSI_TIMEOUT, # timeout
                0,  # flags
                0, # pack id
                0, # user ptr
                0, # status
                0, # masked_status
                0, # msb status
                0, # sb_len_wr,
                0, # host status
                0, # driver status
                0, # dxfer_len
                0, # duration
                0,  # info 
             )

    bufferPrint16(data)
    hndl = open(handle,'r')
        #/dev/dsk/c3t00173800001A0199d0
    res = ioctl(hndl,SG_IO,data)   
    hndl.close()
    bufferPrint16(res,name="Response")
    bufferPrint16(sense_buffer,name="Sense Buffer")
    
    #bufferPrint16(data_ptr, name="Data Buffer", isChar = False)
    
    print scsi_hdr_linux_i386.parse(res)
    #print scsi_hdr_linux_i386.sizeof(scsi_hdr_linux_i386.parse(res))
   

    

def testWrite():
    bufferPrint16(cdb10Write)
    
    cdb_buffer = array('c', '\0' * 16)
    for i in range(len(cdb10Write)):
        cdb_buffer[i] = cdb10Write[i]
    cdb_buffer_ptr, cdb_buffer_len = cdb_buffer.buffer_info()
    
    bufferPrint16(cdb_buffer[0:16])
    
    data_buffer = array('c')
    data_buffer.fromstring(xml_cmd)
    data_buffer_ptr, data_buffer_len = data_buffer.buffer_info()
    
    getStruct('/dev/mapper/mpath0', False, cdb_buffer_ptr, len(cdb10Write), data_buffer_ptr, data_buffer_len)
    
    bufferPrint16(data_buffer, name="Data Buffer", type = "%c", alignment = -1)


def testRead():
    bufferPrint16(cdb10Read)
    
    cdb_buffer = array('c', '\0' * 16)
    for i in range(len(cdb10Read)):
        cdb_buffer[i] = cdb10Read[i]
    cdb_buffer_ptr, cdb_buffer_len = cdb_buffer.buffer_info()
    
    bufferPrint16(cdb_buffer[0:16])
    
    data_buffer = array('c','\0' * XCLI_INPUT_BUFFER_SIZE)
    data_buffer_ptr, data_buffer_len = data_buffer.buffer_info()
   
    
    getStruct('/dev/mapper/mpath0', True, cdb_buffer_ptr, len(cdb10Read), data_buffer_ptr, data_buffer_len)
    
    
    #bufferPrint16(data_buffer[0:4], name="Data Buffer")
    #bufferPrint16(data_buffer[4:2000], name="Data Buffer", type = "%c", alignment = -1)
    response = PascalString("output", UBInt32("length")).parse(data_buffer)
    bufferPrint16(response, name="Data Buffer", type = "%c", alignment = -1)

def testInquiry():
    cdb_buffer = array('c', '\0' * 16)
    for i in range(len(cdbInquiry)):
        cdb_buffer[i] = cdbInquiry[i]
    cdb_buffer_ptr, cdb_buffer_len = cdb_buffer.buffer_info()

    data_buffer = array('B',[0] * DEFAULT_INQUIRY_RESPONSE_SIZE)
    data_buffer_ptr, data_buffer_len = data_buffer.buffer_info()

    bufferPrint16(data_buffer, name="Data Buffer [Before]", isChar = False)
    
    getStruct('/dev/sda', True, cdb_buffer_ptr, len(cdbInquiry), data_buffer_ptr, data_buffer_len)
        
    bufferPrint16(data_buffer, name="Data Buffer", isChar = False)
    
    from xiv_xsf.scsy.scsi_specifications.primary_commands.inquiry import data    
    print data.parse(data_buffer)

testInquiry()
#testWrite()
#testRead()
