#-------------------------------------------------------------------------------------------------
# Copyright (c) International Business Machines Corp., 2009
#
# IBM XIV Storage System Software
#
# Licensed materials provided under the terms of the IBM International Program
# License Agreement. See the Software
# licensing materials that came with the IBM XIV Storage System for terms and
# conditions.
#
#------------------------------------------------------------------------------------------------- 
XCLI_INPUT_BUFFER_SIZE = 2 ** 18
SENSE_BUFFER_SIZE = 2**5 # 32
DEFAULT_INQUIRY_RESPONSE_SIZE = 96

from construct import *
from struct import calcsize


def OSPointer(name):
    if 4 == calcsize("P"):
        return UNInt32(name)
    else:
        return UNInt64(name)
    
def OSUshort(name):
    if 2 == calcsize("H"):
        return UNInt16(name)
    else:
        return UNInt32(name)
    
def OSshort(name):
    if 2 == calcsize("h"):
        return SNInt16(name)
    else:
        return SNInt32(name)
    
def OSUInt(name):
    if 4 == calcsize("I"):
        return UNInt32(name)
    else:
        return UNInt64(name)
    
def OSInt(name):
    if 4 == calcsize("i"):
        return SNInt32(name)
    else:
        return SNInt64(name)
    
    
